//---------------------------------------------------------------------------
#include <vcl.h>
#include <vector.h>

#pragma hdrstop

#include "GraphMain.h"
#include "interval.h"
#include "repere.h"
#include "time.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"

int imax,jmax;

TForm1 *Form1;

bondbox P0;
double Ax,Ay,Bx,By;
box V(2);

vector<double> sx,sy,ax,ay,bx,by;        //sx,sy : objets;  ax,ay,bx,by  : segments


//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
    : TForm(Owner)
{     CheckListBox1->Checked[0]=true;
      CheckListBox1->Checked[1]=false;
    sx.push_back(0);        sy.push_back(0);
    sx.push_back(0);        sy.push_back(14);
    sx.push_back(14);       sy.push_back(14);
    sx.push_back(14);       sy.push_back(6);
    sx.push_back(10);       sy.push_back(6);
    sx.push_back(10);       sy.push_back(8);
    sx.push_back(12);       sy.push_back(8);
    sx.push_back(12);       sy.push_back(12);
    sx.push_back(2);        sy.push_back(12);
    sx.push_back(2);        sy.push_back(2);
    sx.push_back(18);       sy.push_back(2);
    sx.push_back(18);       sy.push_back(18);
    sx.push_back(20);       sy.push_back(18);
    sx.push_back(20);       sy.push_back(0);
    sx.push_back(0);        sy.push_back(0);

    ax.push_back(8);        ay.push_back(10);
    ax.push_back(25);       ay.push_back(10);
    bx.push_back(11);       by.push_back(10);
    bx.push_back(28);       by.push_back(10);

    imax=sx.size()-1;
    jmax=ax.size();

    P0[1]=interval(-28,57);	P0[2]=interval(-1.4,2.7);
    R1=repere(Image1,Inf(P0[1]),Sup(P0[1]),Inf(P0[2]),Sup(P0[2]));
    R2=repere(Image2,-30,80,-30,50);
    pA=NULL;
    pB=NULL;
}


//---------------------------------------------------------------------------
void __fastcall TForm1::ButtonSiviaClick(TObject *Sender)
{   ButtonInitClick(Sender);
    clock_t start,end;
    start=clock();  Sivia(P0);   end=clock();
    Memo1->Text=((end-start)/CLK_TCK);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::ButtonCameleonClick(TObject *Sender)
{   ButtonInitClick(Sender);
    P0[1]=interval(-28,57);	P0[2]=interval(-1.4,2.7);

    clock_t start,end;
    start=clock();
    Cameleon(P0);   end=clock();
    Memo1->Text=((end-start)/CLK_TCK);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormClick(TObject *Sender)
{
    ButtonSivia->Visible=true;
    ButtonCameleon->Visible=true;
    CheckListBox1->Visible=true;
    Memo1->Visible=true;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ButtonInitClick(TObject *Sender)
{   ButtonSivia->Visible=false;
    ButtonCameleon->Visible=false;
    ButtonInit->Visible=false;
    CheckListBox1->Visible=false;
    Memo1->Visible=false;
    Ax=0;Ay=0;Bx=17;By=0;
    smoothpath     =CheckListBox1->Checked[0];
    cobweb         =CheckListBox1->Checked[1];
    V[1]=1;V[2]=10;

}
//---------------------------------------------------------------------------




//---------------------------------------------------------------------------

//---------------------------------------------------------------------------

void __fastcall TForm1::ButtonDrawMotionClick(TObject *Sender)
{
   DrawFullMotion (pB);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Image1MouseMove(TObject *Sender, TShiftState Shift,
      int a, int b)
{
   R2.Clean();  R2.DrawPoint(0,0,clRed,4);
   R1.DrawPoint(0,0,clBlack,4);

   char info[200];
   sprintf(info,"\r\n a=%d    \r\n b=%d",a,b);
   Form1->Memo1->Text=info;


   double xp,yp;
   double da,db;
   da=R1.image->ClientWidth;
   db=R1.image->ClientHeight;
   sprintf(info,"\r\n da= %lf \r\n db %lf",da,db);
   Form1->Memo1->Text=Form1->Memo1->Text+info;


   interval Ixp=R1.interval_x;
   double dxp=Ixp.sup-Ixp.inf;
   interval Iyp=R1.interval_y;
   double dyp=Iyp.sup-Iyp.inf;
   xp = R1.interval_x.inf + ((double)a/da)*(dxp);
   yp = R1.interval_y.sup - ((double)b/db)*(dyp);
   sprintf(info,"\r\n xp= %lf \r\n yp %lf",xp,yp);
   Form1->Memo1->Text=Form1->Memo1->Text+info;

   sprintf(info,"\r\n dxp= %lf \r\n dyp %lf",dxp,dyp);
   Form1->Memo1->Text=Form1->Memo1->Text+info;

   sprintf(info,"\r\n xpinf= %lf \r\n xpsup %lf",Ixp.inf,Ixp.sup);
   Form1->Memo1->Text=Form1->Memo1->Text+info;

   sprintf(info,"\r\n ypinf= %lf \r\n ypsup %lf",Iyp.inf,Iyp.sup);
   Form1->Memo1->Text=Form1->Memo1->Text+info;


   DrawRobot (xp,yp,clBlack);
}
//---------------------------------------------------------------------------

