#include <vcl.h>
#include <vector.h>
#include "interval.h"
#include "bondbox.h"
#include "GraphMain.h"


extern int imax; // nombre de segments pour l'objet  bouger
extern int jmax;  // nombre de segments
extern TForm1 *Form1;
extern box V;
extern double Ax,Ay,Bx,By;
extern vector<double> sx,sy,ax,ay,bx,by;
int k=0;



//*********************************************************************
bondbox::bondbox ():box(2)
{	inside=0;couleur=0;passeur=NULL; distance=0;
}
//--------------------------------------------------------------
bondbox::bondbox (int dim1):box(dim1)
{	inside=0;couleur=0;passeur=NULL; distance=0;}
//----------------------------------------------------------------------
bondbox::bondbox (bondbox &v):box(v)
{	if (this == &v) return;;
    for (int i=1;i<=n;i++)	{left[i]=v.left[i];right[i]=v.right[i];}
	inside	=v.inside;	couleur	=v.couleur;
}
//----------------------------------------------------------------------
bondbox::~bondbox () {	delete [] data;}
//----------------------------------------------------------------------
void TForm1::DrawPath (bondbox* pB,TColor c) //Dessine le chemin de B  A (A n'a pas de passeur).
{	if (pB!=NULL)
	{	if (pB->passeur!=NULL)
		{	double x1,x2,y1,y2;
			x1=Center((*pB)[1]);			y1=Center((*pB)[2]);
			x2=Center((*(pB->passeur))[1]);	y2=Center((*(pB->passeur))[2]);
			R1.DrawLine(	x1,y1,x2,y2,c,psSolid,3);
		}
		DrawPath(pB->passeur,c);
                R1.image->Refresh();
	}
}
//----------------------------------------------------------------------
void TForm1::DrawRobot (double x, double theta,TColor col)
// Pour une config (x,y,theta) dessine l'objet associ et les obstacles
{   //R1.interval_x=interval(-30,80);
    //R1.interval_y=interval(-30,50);
    for (int j=0;j<=ax.size()-1;j++)
       R2.DrawLine(ax[j],ay[j],bx[j],by[j],clBlack,psSolid,2);
    vector<double> xa,ya;
    for (int i=0;i<=sx.size()-1;i++)
    {   double xr=sx[i];double yr=sy[i];
        xa.push_back(x+xr*cos(theta)-yr*sin(theta));
        ya.push_back(0+xr*sin(theta)+yr*cos(theta));
    }
    R2.DrawPolygon(xa,ya,col,1);
    R2.DrawPoint(xa[0],ya[0],clBlack,6);
    R2.DrawLine(-50,0,100,0,clBlack,psSolid,3);
    R2.image->Refresh();
}
//--------------------------------------------------------------
void TForm1::DrawMotion (bondbox* pB,TColor col) //dessine l'objet en mouvement
{   if (pB!=NULL)
	{	DrawMotion(pB->passeur,col);
                R2.Clean();
                R1.DrawBox(*pB,clWhite,clBlack,bsSolid);
                R1.image->Refresh();
                R1.DrawBox(*pB,clPurple,clBlack,bsSolid);
                DrawRobot (Center((*pB)[1]),Center((*pB)[2]),col);
                //k++;
                //R2.image->Picture->SaveToFile("robot_move"+String(10000+k)+".bmp");
                Sleep(50.0);
	}
    R2.image->Refresh();
}
//---------------------------------------------------------------------
void TForm1::Dijkstra(bondbox* pA,bondbox* pB,int t1,int t2, int col)  //Algo du plus court chemin
{	TListe L;
    L.Push(pA);
    bool sortie=false; //Car pB n'a pas ete atteint
    do
    {   pA=(bondbox*) L.GetLast();
        pA->couleur=col;
        L.RemoveCurrent(false);  //A remplacer par PULL
        for (int k=1;k<=pA->dim;k++) //Pour tous les voisins de *pA
	    {	bondbox *pY = (bondbox*) (pA->left[k]).GetFirst();
		    while ((pY != NULL)&&(!sortie))
		    {	if	((pY->couleur!=col)
                    &&((pY->inside==t1)||(pY->inside==t2)))
			    {	pY->couleur=col;  	pY->passeur=pA;
                    L.Push(pY);
                    if (pY==pB) sortie=true;
			    }
			    pY = (bondbox*) (pA->left[k]).GetNext ();
            }
			pY = (bondbox*) (pA->right[k]).GetFirst();
		    while ((pY != NULL)&&(!sortie))
		    {	if	((pY->couleur!=col)
                    &&((pY->inside==t1)||(pY->inside==t2)))
			    {	pY->couleur=col;	pY->passeur=pA;
				    L.Push(pY);
                    if (pY==pB) sortie=true;
			    }
			    pY = (bondbox*) (pA->right[k]).GetNext ();
		    }
        }
	} while ((!L.IsEmpty())&&(!sortie));
    if (!L.IsEmpty()) L.DeleteAll(False);
}
//----------------------------------------------------------------------
void DrawList(repere R,TListe& L,TColor couleur,TBrushStyle pinceau)
{	bondbox *pY = (bondbox*) L.GetFirst();
	while (pY!=NULL)	{	R.DrawBox(*pY,couleur,couleur,pinceau);
							pY = (bondbox*) L.GetNext ();	}
}
//----------------------------------------------------------------------
void TForm1::DrawCobweb(TListe& L,TColor couleur)
{	bondbox *pY = (bondbox*) L.GetFirst();
	while (pY != NULL)
	{	bondbox* pZ = (bondbox*) pY->passeur;
		if (pZ!=NULL)
                       R1.DrawLine (Center((*pY)[1]),Center((*pY)[2]),
                                    Center((*pZ)[1]),Center((*pZ)[2]),
                                    couleur,psSolid,1);
		pY = (bondbox*) L.GetNext ();
                R1.image->Refresh();
	}
}
//---------------------------------------------------------------------
iboolean InRobot(box& A)   //Test si le pav A (de dimension 2) touche ou non les obstacles
{  box s0(2);box s1(2);
   int imax=sx.size()-1;
   for (int i=0;i<=imax-1;i++)
   {   s0[1]=sx[i];   s0[2]=sy[i]; s1[1]=sx[i+1]; s1[2]=sy[i+1];
       interval d=Determinant(s0-s1,s0-A);
       if ((In(0,d)) && (!Disjoint(A,Union(s0,s1)))) return iperhaps;
   }
   box a=Center(A);
   double total=0;
   double alpha;
   for (int i=0; i<=imax-1; i++)
   {  s0[1]=sx[i];   s0[2]=sy[i]; s1[1]=sx[i+1]; s1[2]=sy[i+1];
      alpha=Angle(s0-a,s1-a);
      total=total + alpha;
   }
   if ((total>1)||(total<-1))  return itrue;
   return ifalse;
}
//---------------------------------------------------------------------
iboolean Inside(bondbox &P)   // Test si le pav P (de dimension 3) est ou n'est pas dans
                              // l'ensemble des configs admissibles
{   interval P1=P[1];    interval P2=P[2];
    vector<interval> Ax,Ay,Bx,By;
    double p2c=Center(P2);
    double p1c=Center(P1);
    interval CosP2=Cos(P2);
    double cosp2=cos(p2c);
    interval SinP2=Sin(P2);
    double sinp2=sin(p2c);
    iboolean result=itrue;
    for (int j=0;j<=jmax-1;j++) //pour chaque primitive
    {   //on calcule les coordonnes de A1, B1, A2 et B2 (obstacles) dans le repere de l'objet,
        box A(2);
        box B(2);
        A[1]= CosP2*(ax[j]-P1) + SinP2*(ay[j]);
        double fc=cosp2*(ax[j]-p1c) + sinp2*(ay[j]);      //Les 5 lignes qui suivent diminue le pessimisme
        interval df1=-CosP2;                            //pour A[1] en utilisant la forme centre
        interval df2= -(ax[j]-P1)*SinP2+CosP2*(ay[j]);  // Idem pour A[2], B[1] et B[2]
        interval A1c=fc+df1*(P1-p1c)+df2*(P2-p2c);
        A[1]=Inter(A[1],A1c);
        //
        A[2]=-SinP2*(ax[j]-P1) + CosP2*(ay[j]);
        fc=-sinp2*(ax[j]-p1c) + cosp2*(ay[j]);
        df1=SinP2;
        df2= -(ax[j]-P1)*CosP2-SinP2*(ay[j]);
        interval A2c=fc+df1*(P1-p1c)+df2*(P2-p2c);
        A[2]=Inter(A[2],A2c);
        //
        B[1]= CosP2*(bx[j]-P1) + SinP2*(by[j]);
        fc=cosp2*(bx[j]-p1c) + sinp2*(by[j]);
        df1=-CosP2;
        df2= -(bx[j]-P1)*SinP2+CosP2*(by[j]);
        interval B1c=fc+df1*(P1-p1c)+df2*(P2-p2c);
        B[1]=Inter(B[1],B1c);
        //
        B[2]=-SinP2*(bx[j]-P1) + CosP2*(by[j]);
        fc=-sinp2*(bx[j]-p1c) + cosp2*(by[j]);
        df1=SinP2;
        df2= -(bx[j]-P1)*CosP2-SinP2*(by[j]);
        interval B2c=fc+df1*(P1-p1c)+df2*(P2-p2c);
        B[2]=Inter(B[2],B2c);

        if (InRobot(A)==true) return ifalse;
        if (InRobot(B)==true) return ifalse;
        for (int i=0;i<=imax-1;i++)
        {   //a[j]b[j] coupe le segment du robot, on rejete la configuration
            box s0(2);   s0[1]=sx[i];   s0[2]=sy[i];
            box s1(2);   s1[1]=sx[i+1]; s1[2]=sy[i+1];
            box ds=s1-s0;
            interval d1=Determinant(B-s1,A-s1)*Determinant(B-s0,A-s0);
            interval d2=Determinant(ds,s1-A)*Determinant(ds,s1-B);
            if ((Sup(d1)<=0)&&(Sup(d2)<=0)) return ifalse; // FullCoupure
            bool fullDisjoint=Disjoint(Union(A,B),Union(s0,s1));
            if ((Inf(d1)<=0)&&(Inf(d2)<=0)&&(!fullDisjoint)) result=iperhaps;
        }
    }
    return result;
}
//----------------------------------------------------------------------
void SmoothPath(bondbox* pB)  // Dessine un chemin qui arrondi les angles
{	if (pB!=NULL) if (pB->passeur!=NULL)
	if ((pB->passeur->passeur)!=NULL)
	{	if (In(*pB,*(pB->passeur->passeur))!=ifalse)
			pB->passeur=pB->passeur->passeur;
		SmoothPath(pB->passeur);
	}
}
//---------------------------------------------------------------------
void TForm1::ReseauVersListe(bondbox* pA, TListe &L)
{	// On constitue une liste contenant tous les elements du reseau
	L.Push(pA);
        R1.DrawBox(*pA,clBlack,clBlack,bsSolid);
	pA->couleur=999;
	for (int k=1;k<=pA->dim;k++)
	{	bondbox *pY = (bondbox*) (pA->left[k]).GetFirst();
		while (pY != NULL)
		{	if	(pY->couleur!=pA->couleur)	{ReseauVersListe(pY,L);}
			pY = (bondbox*) (pA->left[k]).GetNext();
		}
		pY = (bondbox*) (pA->right[k]).GetFirst();
		while (pY != NULL)
		{	if	(pY->couleur!=pA->couleur)	{ReseauVersListe(pY,L);}
			pY = (bondbox*) (pA->right[k]).GetNext ();
		}
	}
}
//---------------------------------------------------------------------

void TForm1::DrawFullMotion (bondbox* pB)
{   if (pB==NULL) return;
    R2.Clean();
    DrawRobot (0,0,clPurple); Sleep(500.1);
    //R2.image->Picture->SaveToFile("robot_move0.bmp");
    DrawMotion(pB,clRed);
    R2.Clean();
    DrawRobot (17,0,clPurple); Sleep(500.1);
    //R2.image->Picture->SaveToFile("robot_move20000.bmp");
    DrawPath (pB,clBlack);
}


void TForm1::CleanAll (bondbox* pP)
{ if (pP==NULL) return;
  TListe Ldel;
  ReseauVersListe(pP,Ldel);
  Ldel.DeleteAll(true);
  pA=NULL;
}
//---------------------------------------------------------------------
void TForm1::Sivia (bondbox &P)
{	CleanAll (pA);
        TListe L;  Form1->R1.Clean();
        box A(2);A[1]=interval(Ax,Ax);A[2]=interval(Ay,Ay);
	box B(2);B[1]=interval(Bx,Bx);B[2]=interval(By,By);
	bondbox* pP= new bondbox(2);
       *pP=P; L.Push(pP);
	do
	{	R1.image->Refresh();
                pP = (bondbox*) L.GetLast();
                L.RemoveCurrent(false);
		iboolean test=Inside(*pP);
    	        if (In(A,*pP)==true) pA=pP;
                if (In(B,*pP)==true) pB=pP;
                if (test==false)
		   {
                      R1.DrawBox(*pP,clBlue,clBlack,bsSolid);
                      pP->inside=-1;
                   }
		else if	(test==true)
                   {	R1.DrawBox(*pP,clRed,clBlack,bsSolid);
                        pP->inside=1;
                   }
		else if ((*pP).Width()< 0.1)
		   {   Form1->R1.DrawBox(*pP,clYellow,clLime,bsSolid);
                       pP->inside=0;
                   }
		else
                   {	bondbox* pP1= new bondbox(2);
		    	bondbox* pP2= new bondbox(2);
		    	Bisect(*pP, *pP1, *pP2);L.Push(pP1);L.Push(pP2);
		    	delete pP;
                   }
	}
	while (L.GetFirst()!=NULL);
    Dijkstra(pA,pB,0,1,777);
    if (smoothpath) SmoothPath(pB);
    DrawPath (pB,clBlack);
    
    if (cobweb)
     { TListe L2;
       ReseauVersListe(pP,L2);
       DrawCobweb(L2,clWhite);
       L2.DeleteAll(false);
     }

     L.DeleteAll(false);
//    CleanAll (pA);
}



//---------------------------------------------------------------------
void TForm1::Cameleon (bondbox &P)
{   int k=0;
    CleanAll (pA);
    Form1->R1.Clean();
    box A(2);A[1]=interval(Ax,Ax);A[2]=interval(Ay,Ay);
    box B(2);B[1]=interval(Bx,Bx);B[2]=interval(By,By);
    bondbox* pP= new bondbox(2);
    *pP=P; pA=pP; pB=pP; pP->inside=0;
    int l=3;
    do
    {   Dijkstra(pA,pB,1,1,l++);
        if ((pA->couleur==pB->couleur)&&(pA!=pB)) break; //on a trouve le chemin
        Dijkstra(pA,pB,1,0,l++);
        if (pA->couleur!=pB->couleur) break; //impossible de trouver un chemin
        // On fabrique le path jaune qu'il nous faut creuser
        TListe pathjaune;
        pP=pB;
        do
        {   //if (pP->inside==0)
            pathjaune.Push(pP);
            R1.DrawBox(*pP,clGreen,clBlue,bsSolid);
            pP=pP->passeur;
        } while (pP!=NULL);


//        k++;
//        R1.image->Picture->SaveToFile("cameleon"+String(10000+k)+".bmp");


        R1.image->Refresh();
        //On bisecte tous pavs de pathjaune
        do
        {   pP = (bondbox*) pathjaune.GetFirst();
            pathjaune.RemoveCurrent(false);
            if (pP->inside==1) Form1->R1.DrawBox(*pP,clRed,clBlack,bsSolid);
            else
            {   bondbox* pP1= new bondbox(2);
                bondbox* pP2= new bondbox(2);
		        Bisect(*pP, *pP1, *pP2);
                delete pP;
                // Pout le fils 1
		        iboolean test1=Inside(*pP1);
    	        if (In(A,*pP1)==true) pA=pP1;
                if (In(B,*pP1)==true) pB=pP1;
                if (test1==false)     {R1.DrawBox(*pP1,clBlue,clBlack,bsSolid);pP1->inside=-1;}
		        else if	(test1==true) {Form1->R1.DrawBox(*pP1,clRed,clBlack,bsSolid);pP1->inside=1;}
                else  	              {Form1->R1.DrawBox(*pP1,clYellow,clLime,bsSolid);pP1->inside=0;}
                // Pout le fils 2
		        iboolean test2=Inside(*pP2);
    	        if (In(A,*pP2)==true) pA=pP2;
                if (In(B,*pP2)==true) pB=pP2;
                if (test2==false)     {R1.DrawBox(*pP2,clBlue,clBlack,bsSolid);pP2->inside=-1;}
                else if	(test2==true) {R1.DrawBox(*pP2,clRed,clBlack,bsSolid);pP2->inside=1;}
                else {R1.DrawBox(*pP2,clYellow,clLime,bsSolid);pP2->inside=0;}
            };
        } while(!pathjaune.IsEmpty());
	} while (true);
    if (smoothpath) SmoothPath(pB);
    DrawPath (pB,clBlack);

    //  k++;  R1.image->Picture->SaveToFile("cameleon"+String(10000+k)+".bmp");
}


//*********************************************************************
//******************    FUNCTIONS MEMBRES     *************************
//*********************************************************************
void bondbox::operator= (bondbox& v)
{	 if (this == &v) return;
	 delete [] data;
	 dim=v.dim;
	 data=new interval[dim];
	 for (int k=1; k<=dim; k++) (*this)[k]=v[k];
         for (int i=1;i<=n;i++) {left [i]=v.left [i];right[i]=v.right[i];}
         inside=v.inside;	couleur=v.couleur;
}


//----------------------------------------------------------------------
//*********************************************************************
//******************    FONCTION NON MEMBRES     **********************
//*********************************************************************
//----------------------------------------------------------------------

void Bisect(bondbox& x, bondbox& x1, bondbox& x2)
	{	BisectAlong(x,x1,x2,AxePrincipal(x,V));	}
//----------------------------------------------------------------------
BOOL VoisinLeftRight(box& X1,box& X2,int i)
{	BOOL a=TRUE;
	if (Sup(X1[i])!=Inf(X2[i])) 
		return FALSE;
	for (int k=1;k<=n;k++)
		{ 	interval X1k=X1[k];
			interval X2k=X2[k];
			a=OverLap(X1k,X2k);
			if ((k!=i)&&(!a)) return FALSE;
		}
	return TRUE;
}
//----------------------------------------------------------------------
void BisectAlong (bondbox& X, bondbox& X1, bondbox& X2, int i)
{	X1=X;X2=X;
	double mx = Center(X[i]);
	(X1[i]).sup=mx;
        (X2[i]).inf=mx;
	for (int k=1;k<=n;k++)
	{	if (k==i)
		{	X1.right[k].DeleteAll (false);	X2.left [k].DeleteAll (false);
			X1.right[k].Push(&X2);		X2.left [k].Push(&X1);
			bondbox *pY = (bondbox*) (X.left[k]).GetFirst ();
			while (pY != NULL)
			{	(pY->right[k]).RemoveInTheList(&X);	(pY->right[k]).Push(&X1);
				pY = (bondbox*) (X.left[k]).GetNext ();
			}
			pY = (bondbox*) (X.right[k]).GetFirst ();
			while (pY != NULL)
			{	(pY->left[k]).RemoveInTheList(&X);	(pY->left[k]).Push(&X2);
				pY = (bondbox*) (X.right[k]).GetNext ();
			}
		}
		else
		{	bondbox *pY = (bondbox*) (X.left[k]).GetFirst ();
			while (pY != NULL)
			{	(pY->right[k]).RemoveInTheList(&X);
				if (VoisinLeftRight(*pY,X1,k))	(pY->right[k]).Push(&X1);
				else 	(X1.left[k]).RemoveInTheList(pY);
				if (VoisinLeftRight(*pY,X2,k))	(pY->right[k]).Push(&X2);
				else (X2.left[k]).RemoveInTheList(pY);
				pY = (bondbox*) (X.left[k]).GetNext ();
			}
			pY= (bondbox*) (X.right[k]).GetFirst ();
			while (pY!=NULL)
			{	(pY->left[k]).RemoveInTheList(&X);
				if (VoisinLeftRight(X1,*pY,k))	(pY->left[k]).Push(&X1);
				else (X1.right[k]).RemoveInTheList(pY);
				if (VoisinLeftRight(X2,*pY,k))	(pY->left[k]).Push(&X2);
				else (X2.right[k]).RemoveInTheList(pY);
				pY = (bondbox*) (X.right[k]).GetNext ();
			}
		}
	}
}
//-----------------------------------------
